Skip to main content

criticalPath

The functionality is available in PRO Edition only

PRO

Description

Optional. Enables critical path calculation and visualization in Gantt

The criticalPath property enables built-in Critical Path Method (CPM) analysis in the Gantt chart. It identifies the sequence of tasks that defines the minimum project duration. If there are multiple parallel paths with the same duration, the chart will highlight the first valid path.

When enabled, critical tasks and links receive a critical boolean property (task.critical and link.critical) set to true for elements that belong to the critical path.

Usage

criticalPath?: {
type: "strict" | "flexible";
};

Parameters

The property accepts an object specifying the calculation mode.

  • type - (required) - defines the algorithm used to compute the critical path:
    • "strict" - classical CPM mode that identifies tasks with exactly zero total slack. Uses backward traversal from project end, selecting only predecessors with zero slack. When multiple zero-slack predecessors exist, chooses the one with highest path count (longest path). Returns an empty array if no complete zero-slack path exists.
    • "flexible" - flexible mode for near-critical path analysis. Uses forward traversal from project start, greedily selecting the successor with minimum adjusted slack at each decision point. Always returns a path, making it useful when no complete zero-slack path exists or when analyzing near-critical tasks.

The following Gantt props influence strict critical-path calculations:

Example

import { useState } from "react";
import { getData } from "../data";
import { Gantt } from "@svar-ui/react-gantt";

const data = getData("critical");

function App() {
const [mode] = useState("flexible");
const projectStart = new Date(2024, 3, 2);
const projectEnd = new Date(2024, 3, 12);

return (
<Gantt
tasks={data.tasks}
links={data.links}
scales={data.scales}
criticalPath={{ type: mode }}
projectStart={projectStart}
projectEnd={projectEnd}
/>
);
}

export default App;

Related sample: Critical path

criticalPath
PRO
The functionality is available in PRO Edition only
Description
Optional. Enables critical path calculation and visualization in GanttThe criticalPath property enables built-in Critical Path Method (CPM) analysis in the Gantt chart. It identifies the sequence of tasks that defines the minimum project duration.
If there are multiple parallel paths with the same duration, the chart will highlight the first valid path.
When enabled, critical tasks and links receive a
criticalboolean property (task.criticalandlink.critical) set totruefor elements that belong to the critical path.
Usage
criticalPath?: {
type: "strict" | "flexible";
};
Parameters
The property accepts an object specifying the calculation mode.
type- (required) - defines the algorithm used to compute the critical path:- "strict" - classical CPM mode that identifies tasks with exactly zero total slack. Uses backward traversal from project end, selecting only predecessors with zero slack. When multiple zero-slack predecessors exist, chooses the one with highest path count (longest path). Returns an empty array if no complete zero-slack path exists.
- "flexible" - flexible mode for near-critical path analysis. Uses forward traversal from project start, greedily selecting the successor with minimum adjusted slack at each decision point. Always returns a path, making it useful when no complete zero-slack path exists or when analyzing near-critical tasks.
The following Gantt props influence strict critical-path calculations:
Example
<script setup>
import { ref } from "vue";
import { getData } from "../data";
import { Gantt } from "@svar/vue-gantt";
const data = getData("critical");
const api = ref();
const mode = "flexible";
const projectStart = new Date(2024, 3, 2);
const projectEnd = new Date(2024, 3, 12);
</script>
<template>
<Gantt
:tasks="data.tasks"
:links="data.links"
:scales="data.scales"
:criticalPath="{ type: mode }"
:projectStart="projectStart"
:projectEnd="projectEnd"
/>
</template>
Related sample:
Related articles: